
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>XMOVE3.0手持终端——软件介绍(三):在2KB内存的单片机上实现的的俄罗斯方块 （原创） / iVAN</title>

    <meta name="description" content="XMOVE3.0手持终端——软件介绍(三):在2KB内存的单片机上实现的的俄罗斯方块 （原创） 一. 综述 这也是我两年前完成的小项目,它基于我开发的XMOVE动作感应系统平台.    与XMOVE手持终端相关的介绍文章列表如下: 硬件综述: 自制的彩屏手持动作感应终端 软件综述:手持终端功能介绍 软件介绍(一):精简型嵌入式系统的菜单实现和任务切换 软件介绍(二):在2KB内存单片机上实现的彩屏GUI控件库 软件介绍(三):在2KB内存单片机上实现的俄罗斯方块 软件介绍(四):在2KB内存单片机上实现的超精简五子棋算法 软件介绍(五):在2KB内存的单片机上实现的T9中文输入法 相对于五">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">XMOVE3.0手持终端——软件介绍(三):在2KB内存的单片机上实现的的俄罗斯方块 （原创）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>一. 综述</h2>
<p>　　</p>
<p>　　这也是我两年前完成的小项目，它基于我开发的<a href="http://www.cnblogs.com/buptzym/archive/2012/06/15/2417040.html" rel="external nofollow noreferrer">XMOVE动作感应系统平台</a>。</p>
<p>   与XMOVE手持终端相关的介绍文章列表如下:</p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/29/2570546.html" rel="external nofollow noreferrer">硬件综述: 自制的彩屏手持动作感应终端</a></p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/29/2570553.html" rel="external nofollow noreferrer">软件综述:手持终端功能介绍</a></p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/22/2557460.html" rel="external nofollow noreferrer">软件介绍(一):精简型嵌入式系统的菜单实现和任务切换</a>　　</p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/26/2564401.html" rel="external nofollow noreferrer">软件介绍(二):在2KB内存单片机上实现的彩屏GUI控件库</a></p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/20/2556918.html" rel="external nofollow noreferrer">软件介绍(三):在2KB内存单片机上实现的俄罗斯方块</a></p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/20/2556052.html" rel="external nofollow noreferrer">软件介绍(四):在2KB内存单片机上实现的超精简五子棋算法</a></p>
<p>　　<a href="http://www.cnblogs.com/buptzym/archive/2012/06/23/2559195.html" rel="external nofollow noreferrer">软件介绍(五):在2KB内存的单片机上实现的T9中文输入法</a></p>
<p>　　相对于五子棋，俄罗斯方块算法更是满天飞。我的代码还是相对好移植的，看起来也更清晰，方便学弟学妹们做编程小学期时移植。不过要做就要做的有特色：它运行在软硬件由我们独立开发的平台上。以下是截图：</p>
<p>　　</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzI4NzA2MC8yMDEyMDYyMDIwMDQyMTM4LmpwZw==.jpg"></p>
<p>　　</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzI4NzA2MC8yMDEyMDYyMDIwMDQ0NTc3LmpwZw==.jpg"></p>
<p>　　有如下特点：</p>
<ul>
<li>　　　　跑在独立开发的平台上，平台为MSP430F149，内存2KB,频率8MHz</li>
<li>支持体感：可以通过左右倾斜来左右移动方块，还可以上下抖动改变方块形状</li>
<li>代码精简，方便移植</li>
<li>内存占用率极低</li>
<li>支持横屏和竖屏操作</li>
<li>支持等级:用户在达到一定分数后，等级会上升，从而方块下落速度变得更快</li>
</ul>
<h2>二. 系统设计</h2>
<p>　　我们将问题细化为以下几个方面：</p>
<p>　　1. 方块的形状如何存储</p>
<p>　　俄罗斯方块总共有19种形状，每种形状都由四个小方块组成。如何高效存储这些方块的形状是个值得思考的问题。</p>
<p>　　</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzI4NzA2MC8yMDEyMDYyMDIwMzA0NjYzLmpwZw==.jpg"></p>
<p>  上图介绍了存储方法：</p>
<p>　　我们用以下数组保存形状：</p>
<pre><code>const unsigned char  BoxShape[19][9]=
{    

    { 1,0,0,1,1,1,2,1,1  },
    { 1,0,1,1,2,1,1,2,2  },
    { 0,0,1,0,2,0,1,1,3  },
    { 1,0,0,1,1,1,1,2,0  },   

    { 1,0,2,0,1,1,1,2,5  },
    { 0,0,1,0,2,0,2,1,6  },
    { 2,0,2,1,2,2,1,2,7  },
    { 0,0,0,1,1,1,2,1,4  },   

    { 1,0,2,0,2,1,2,2,9  },
    { 2,0,0,1,1,1,2,1,10 },
    { 1,0,1,1,1,2,2,2,11 },
    { 0,0,1,0,2,0,0,1,8  },   

    { 0,0,0,1,1,1,1,2,13 },
    { 1,0,2,0,0,1,1,1,12 },   

    { 2,0,1,1,2,1,1,2,15 },
    { 0,0,1,0,1,1,2,1,14 },   

    { 1,0,1,1,1,2,1,3,17 },
    { 0,1,1,1,2,1,3,1,16 },   

    { 1,0,2,0,1,1,2,1,18 }
};</code></pre>
<p> 2. 如何解决各个方块的互相转换的顺序：</p>
<p>　　以上的数组已经解决了这一问题，多维数组的最后一位即该形状发生改变后的下一个形状。</p>
<p> 3. 如何存储当前的画布信息</p>
<p>　　</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzI4NzA2MC8yMDEyMDYyMDIwNTU1MDQyLmpwZw==.jpg"></p>
<p> 3. 如何解决碰撞问题：</p>
<p>　　这大概是算法当中最值得考虑的了，我们用以下四个函数解决：</p>
<p>　　所有的函数形参类似，它们的定义分别是：</p>
<p>　　XAxi,YAxi：存储当前形状的左上角的点在画布中的实际偏移量。</p>
<p>　　Data[][22]：存储的画布数据</p>
<p>　　Type:当前形状的ID(即BoxSharp的数组偏移量)</p>
<pre><code>u8 Bottom_Anti(u8 XAxi ,u8 YAxi,u8  Data[][22],u8 Type)
{
    u8 i;
    u8 Value=1;
    for(i=0;i&lt;4;i++)
    {
        if(Data[XAxi+BoxShape[Type][2*i]][YAxi+BoxShape[Type][2*i+1]+1]==1)
            Value=0;
    }
    return Value;
}
u8 Right_Anti(u8 XAxi ,u8 YAxi,u8  Data[][22],u8 Type)
{
    u8 i;
    u8 Value=1; 

    for(i=0;i&lt;4;i++)
    {
        if(Data[XAxi+BoxShape[Type][2*i]+1][YAxi+BoxShape[Type][2*i+1]]==1)
            Value=0;
    }
    return Value;     

}
u8 Lift_Anti(u8 XAxi ,u8 YAxi,u8  Data[][22],u8 Type)
{
    u8 i;
    u8 Value=1; 

    for(i=0;i&lt;4;i++)
    {
        if(Data[XAxi+BoxShape[Type][2*i]-1][YAxi+BoxShape[Type][2*i+1]]==1)
            Value=0;
    }
    return Value;    

}
u8 Change_Anti(u8 XAxi ,u8 YAxi,u8  Data[][22],u8 *Type)
{
    u8 i;
    u8 Value=1;
    for(i=0;i&lt;4;i++)
    {
        if(Data[XAxi+BoxShape[BoxShape[*Type][8]][2*i]][YAxi+BoxShape[BoxShape[*Type][8]][2*i+1]]==1)
            Value=0; //???????????
    }
    return Value;   

}</code></pre>
<p>   算法本身很清晰，分别检测四个方块在改变后的实际位置是否已经有墙壁或方块存在。这个属性用临时变量Value存储，默认为1，如发现碰撞，则赋值为0并返回。 </p>
<p>4. 如何判断某一行已经被填充满并计分？</p>
<p>　　下面是代码，很简单，检测该行的10个方格是不是都填满了，若填满，则加分，并重新刷新LCD</p>
<pre><code>void CheckMark(u8 *mark ,u8  Data[][22],u8 dir)
{
    u8 m,t,s;
    u8 tMark=0;

    for(m=20;m&gt;2;m--)
    {
        tMark=0;
        for(t=1;t&lt;11;t++)
        {
            if(Data[t][m]==1)
                tMark++;
        }
        if(tMark==10)
        {
            for(t=m;t&gt;2;t--)
            {
                for(s=1;s&lt;11;s++)
                {
                    Data[s][t]= Data[s][t-1];
                }
            }
            m++;
            TotalRefreshLCD(Data,dir);
            delay_ms(200);
            (*mark)++;
        }
    }
}</code></pre>
<p>  5. 如何产生方块？并检查方块已经顶到头？</p>
<p>　　代码如下：（值得讨论的是，在单片机中如何产生随机数？）</p>
<pre><code>void GenerateBox(u8 *XAxi ,u8 *YAxi,u8 *Type,u8 Data[][22],u8 *FailFlag)
{
    u8 temp;
    *XAxi=5;
    *YAxi=2;
    *Type=random(0,18);  //产生随机数

    for(temp=2;temp&lt;10;temp++)
    {
        if(Data[temp][2]==1)   //若在画布上的第3行出现方块，则失败
        {
            *FailFlag=2;
            return;
        }
    }    

}</code></pre>
<p>   好了，这些核心问题我们都讨论完了，下面讨论核心流程。</p>
<h2>三 . 核心处理流程</h2>
<p>　　若加上全部处理，包括刷新界面，显示欢迎界面，显示失败和分数界面，那么还是很冗长的。这些对于实现核心算法无益，我们也不需要关心。</p>
<p>　　下面是流程图：</p>
<p>　　</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcGljMDAyLmNuYmxvZ3MuY29tL2ltYWdlcy8yMDEyLzI4NzA2MC8yMDEyMDYyMDIxMjAzODY4LmpwZw==.jpg"></p>
<p>   主要操作代码如下，使用了状态机，请注意看OS_func_state==1的流程，这是系统在运行时的主要流程。</p>
<pre><code>主要核心操作流程

u8 TerisBrick()
{
    u8 grade=0,mark=0;
    u8 GameGUIData[12][22];
    u8 KeyTemp;
    u8 XAxi,YAxi,Type,OriGrade=0;

        TickControlEN=1;
    u8* temp[2];
    u8 dir=0;

    temp[0]="竖版游戏模式";
    temp[1]="横版游戏模式";
         if(AccControlEN==1)
                        {

                            ADXL345Init(0);
                        }

    while(OS_func_state&lt;10)
    {
        switch(OS_func_state)
        {
        case 0:
            GUI_GameOpen("俄罗斯方块",&amp;grade);

            OriGrade=grade;
            dir=ListGUI(temp,"选择游戏方向",2);  //dir 表征运动方向，0：横版，1竖版
            dir--;
            Clear_Screen();
            OS_func_state=1;

            break;
        case 1:

            TerisBrickInit(GameGUIData,12,22);
            _EINT();
            SetPaintMode(1,COLOR_Black);
            if(dir==0)
            {
                Rectangle(30,22,110,190,1);

            }
            else
                Rectangle(22,32,232,132,1);
            PutString(275,70,"grade");
            PutString(275,110,"mark");
            Lcd_disp(2,200,"左右方向键移动，下键加速，上改变形状");
            while(OS_func_state==1)
            {
                          back_light=back_light_set;
                          FontSetTotal(COLOR_Black);

            NumberDis(275,90,grade,3,1);
            NumberDis(275,130,mark,3,1);
            GenerateBox(&amp;XAxi,&amp;YAxi,&amp;Type,GameGUIData,&amp;OS_func_state);
            while(Bottom_Anti(XAxi,YAxi,GameGUIData,Type))
            {       key_data=KEYNULL;
            ShowBoxGUI(XAxi,YAxi,Type,1,dir);
                        if(AccControlEN==1)
                        {
                          ADXL345ReadData();
                          ADXL345ShowData(0);
                          L3G4200DReadData();
                          L3G4200DShowData();
                        }
            if(KeyTemp==KEYDOWN_DOWN)
                delay_ms(150);
            else
                delay_ms(500-70*grade);

            ShowBoxGUI(XAxi,YAxi,Type,0,dir);
            YAxi++;
            if(AccControlEN==1)
                        {
                              if(dir==0)  //横版
                          {
                            if(AccX&gt;3)
                              key_data=KEYLEFT_UP    ;
                             else if(AccX&lt;-3)
                              key_data=KEYRIGHT_UP  ;
                             if(GyroY&gt;400||GyroY&lt;-400)
                             {
                               key_data=KEYUP_UP  ;
                                 delay_ms(200);
                             }

                          }
                          else
                          {
                             if(AccY&gt;3)
                              key_data=KEYLEFT_UP    ;
                             else if(AccY&lt;-3)
                              key_data=KEYRIGHT_UP  ;
                               if(GyroX&gt;400||GyroX&lt;-400)
                               {
                               key_data=KEYUP_UP  ;
                               delay_ms(200);
                               }

                          }
                        }
            switch(key_data)
            {
            case KEYLEFT_UP    :
                if(Lift_Anti(XAxi,YAxi,GameGUIData,Type)!=0)
                    XAxi--;
                break;
            case KEYRIGHT_UP  :

                if(Right_Anti(XAxi,YAxi,GameGUIData,Type)!=0)
                    XAxi++;

                break;
            case KEYUP_UP  :
                if(Change_Anti(XAxi,YAxi,GameGUIData,&amp;Type)!=0)
                    Type=BoxShape[Type][8];
                break;
            case KEYDOWN_UP  :

                if(Bottom_Anti(XAxi,YAxi,GameGUIData,Type))
                    YAxi++;
                break;

            case KEYCANCEL_UP    :
                if(MessageGui("提示信息","是否跳出?",1)==1)
                {
                                         TickControlEN=1;
                    OS_func_state=2;
                    return 1;
                }
                else
                    TotalRefreshLCD(GameGUIData,dir);
                break;

            }
            KeyTemp=key_data;
                        key_data=KEYNULL;
            }

            for(u8 t=0;t&lt;4;t++)
            {
                GameGUIData[XAxi+BoxShape[Type][2*t]][YAxi+BoxShape[Type][2*t+1]]=1;
            }
            ShowBoxGUI(XAxi,YAxi,Type,1,dir);
            CheckMark(&amp;mark,GameGUIData,dir);
            grade=OriGrade+mark/10;

            } 

            break;
        case 2:
            if(mark==0)
                MessageGui("超级菜鸟","学习下游戏规则",0);
            else if(mark&gt;0&amp;&amp;mark&lt;10)
                MessageGui("初学者","你还要加油哦",0);
            else if(mark&gt;9&amp;&amp;mark&lt;20)
                MessageGui("中级水平","哥们你很牛逼",0);
            else if(mark&gt;19&amp;&amp;mark&lt;30)
                MessageGui("高级水平","无敌哥！膜拜",0);
            else
                MessageGui("超级无敌","不是一般人！！",0);
            if( MessageGui("提示信息","是否继续",1)==1)
                OS_func_state=0;
            else
            {
                          TickControlEN=1;
                OSTaskClose();

            }
            break;

        }
        }

        return 1;

}</code></pre>
<p><h2>四. 其他模块</h2>
<p>　　其他模块主要包括界面显示，分数显示，方块显示和键盘输入等。考虑到和平台相关，因此不具备移植性，贴在下面仅供参考。</p>
<p>　　1. 初始化界面绘图画布数组，主要是建立“围栏”</p>
<pre><code>void TerisBrickInit(u8  Data[][22],u8 i,u8 j)
{

    u8  a,b;
    for(b=0;b&lt;i;b++)
    {
        for(a=0;a&lt;j;a++)
            Data[b][a]=0;
    }
    for(b=0;b&lt;j;b++)
    {
        Data[0][b]=1;
        Data[11][b]=1;
    }
    for(a=0;a&lt;i;a++)
    {
        Data[a][0]=1;
        Data[a][21]=1;
    }

}</code></pre>
<p>   2. 绘制方块和刷新界面</p>
<pre><code>绘制界面和方块

void  ControlBox(u8 x,u8 y,u8 mood,u8 dir)
{
    //dir指出方向，0,为横版，1为竖版
    if(mood==1)
    {       SetPaintMode(0,COLOR_Black);
    if(dir==1)
        Rectangle(22+10*y,22+10*x,32+10*y,32+10*x,1);
    else 

        Rectangle(22+8*x,22+8*y,30+8*x,30+8*y,1);
    SetPaintMode(0,COLOR_Red);
    if(dir==1)
        Rectangle(23+10*y,23+10*x,31+10*y,31+10*x,1);
    else
        Rectangle(23+8*x,23+8*y,29+8*x,29+8*y,1);
    }

    else
    {
        SetPaintMode(1,COLOR_Black);
        if(dir==1) 

            Rectangle(22+10*y,22+10*x,32+10*y,32+10*x,1);
        else
            Rectangle(22+8*x,22+8*y,30+8*x,30+8*y,1);

    }

}
void TotalRefreshLCD(u8  Data[][22],u8 dir)
{
    u8 t,s;
    SetPaintMode(1,COLOR_Black);
    if(dir==0)

        Rectangle(30,22,110,190,1);

    else
        Rectangle(22,32,232,132,1);  

    for(t=1;t&lt;11;t++)
    {
        for(s=2;s&lt;21;s++)
        {
            if(Data[t][s]==1)
                ControlBox(t,s,1,dir);
        }
    }

}</code></pre>
<p><h2>五. 总结</h2>
<p>　　本科一年级时候写过一个俄罗斯方块，代码冗长可读性极差，各种判断和奇怪的变量，最后还有一堆BUG。 这套代码算是对当时愚蠢的我的补偿吧，其实写的也不怎么地。比如，画布大小必须是22*12么？为什么不可变？</p>
<p>　　蛮想把我开发的这套系统拿出来给大家分享的，可惜自制硬件就是这样：给自己带来了快乐，给别人带来了开发和移植的麻烦。</p>
<p>　　说多了，呵呵</p>
<p>　　有任何问题，欢迎随时交流。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:38:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>XMOVE3.0手持终端——软件介绍(三):在2KB内存的单片机上实现的的俄罗斯方块 （原创）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrW2Yvp.html" rel="bookmark">XMOVE3&period;0手持终端&mdash;&mdash;软件介绍&lpar;二&rpar;&colon;在2KB内存的单片机上实现的彩屏GUI控件库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 综述 嵌入式系统发展日新月异,安卓和ios已然战胜了当年雄霸天下的塞班,界面是我们特别看重的因素之一.不过你考虑过自己做一套系统,写一个界面库么?在单片机上自制系统,可以很好的锻炼编程能力和架构设计能力. 这些界面库都是在底层画点画线的驱动程序上实现的,基于我的XMOVE动作感应系统.基本具有硬件无关性.支持彩屏320*240的分辨率,由于考虑不同分辨率的开发过分复杂(想想看你需要计算每个点布局在哪个位置,这对安卓等系统都是大问题),因此我并没有太过完善的考虑过其他分辨率. 我已经写过一篇			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWkwOz.html" rel="bookmark">XMOVE3&period;0手持终端&mdash;&mdash;软件介绍&lpar;五&rpar;&colon;在2KB内存的单片机上实现的T9中文输入法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编者注: X-MOVE是作者在业余时间于2010年6月份启动的以运动传感开发,算法和应用的平台,目前已经发展了三个版本,第四版的开发接近尾声.发布在博客园仅为交流技术,不存在商业目的,作者保留一切权利.   一. 综述      所谓T9,指的是在手机上广为流传的九宫格输入法.中文输入法大家每天都在使用,那么多大的空间才能承载一个输入法呢?搜狗安装包已经20M了,手机版本的也有2M.但我会告诉你,实现中文输入法仅需要14KB的存储空间和不到100byte的内存.虽然没有联想,并只支持拼音,但已经			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M60jYOz.html" rel="bookmark">XMOVE3&period;0手持终端&mdash;&mdash;软件介绍&lpar;四&rpar;&colon;在2KB内存的单片机上实现的超精简五子棋对战算法（原创）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 综述 这是我两年前完成的一个小项目,它基于我开发的XMOVE动作感应系统平台.五子棋算法网上随便一搜到处都是,不过值得自豪的是,我在2KB内存的单片机上不仅跑上了我自制的嵌入式OS,还能同时跑五子棋.这是界面截图:  以下是它的功能和特性: 内存占用极低,约600byte 执行一次迭代过程,算法在初级水平(同学,这是单片机,不是电脑!) 在8MHz的MSP430上算法执行时间不超过0.3s 支持人机对战,双人对战和无线对战(通过NRF24L01实现) 代码精简 嵌入式彩屏GUI实现 支持陀			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJqPe8p.html" rel="bookmark">XMOVE3&period;0手持终端&mdash;&mdash;软件介绍&lpar;一&rpar;&colon;精简型嵌入式管理系统的菜单实现和任务切换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编者注: X-MOVE是作者在业余时间于2010年6月份启动的以运动传感开发,算法和应用的平台,目前已经发展了三个版本,第四版的开发接近尾声.发布在博客园仅为交流技术,不存在商业目的,作者保留一切权利.        一. 综述和废话 本系统是我的XMOVE动作感应系统框架的嵌入式实现部分. 一提到OS一般都会被人喷.OS是何等庞大的东西,区区小辈凭什么敢把自己的几百行代码称之为OS?叫做框架都不行!  有句话叫简单就是美.方便移植,使用简单的c语言框架,在单片机上再合适不过了. 想象一下,一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAnYEM.html" rel="bookmark">XMOVE3&period;0手持终端&mdash;&mdash;综述&colon;软硬件全部自行开发的彩屏体感控制器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编者注: X-MOVE是作者在业余时间于2010年6月份启动的以运动传感开发,算法和应用的平台,目前已经发展了三个版本,第四版的开发接近尾声.发布在博客园仅为交流技术,不存在商业目的,作者保留一切权利.   一. 综述 乔布斯曾经说过:做软件的人应该也制造属于自己的硬件. 不觉得每天给电脑,手机开发程序很不爽么? 为什么总是要&quot;给别人打工&quot;,用别人的SDK? 小时候特别羡慕有文曲星的同学,也特别梦想自己做一个. 在大四这个理想也成为了现实. 我启动了我自己的体感项目XMOVE的2.0版			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7Y25RM.html" rel="bookmark">&lbrack;XMOVE自主设计的体感方案&rsqb; 历代版本系统介绍（三）X-MOVE3&period;0</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编者注: X-MOVE是作者在业余时间于2010年6月份启动的以运动传感开发,算法和应用的平台,目前已经发展了三个版本,第四版的开发接近尾声.发布在博客园仅为交流技术,不存在商业目的,作者保留一切权利. 一 . 前言 XMOVE3.0是2.0版本上的升级版本,硬件改动不大,改动主要集中在软件和算法的升级.它的开发时间是2011年1月--2011年6月,开端于大四寒假,结束于北邮创新展. 它的发展,也是我转变思维的过程.曾经的我,认为硬件是王道,软件只是装饰硬件的皮.甚至,我会觉得开发软件的人都太			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlndRz.html" rel="bookmark">旋风备忘录0&period;10软件介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				软件名称:旋风备忘录0.10 英文名称:CquMemo支持机型:Java通用版本,支持所有Java机型旋风备忘录介绍 软件名称:旋风备忘录英文名称:CquMemo当前版本:0.10Beta 1.软件介绍该软件可以实现在手机中记录各种信息,可以保存您的日程安排.会议记录和重要事件备忘等信息.目前该软件只是最初的版本,如果您有什么好的意见和建议,可以和我联系. 2.功能介绍:该软件主要实现备忘录功能,现在具备的功能如下:A.为该软件设置进入密码.通过这个功能,可以在一定程度上保护您的个人隐私.B.修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6LGlz.html" rel="bookmark">《鸟哥的Linux 私房菜 基础学习篇（第三版）》&mdash;&mdash;0&period;4　软件程序运行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				0.4 软件程序运行 鸟哥的Linux 私房菜 基础学习篇(第三版) 鸟哥在上课时经常会开玩笑地问:&quot;我们知道没有插电的计算机是一堆废铁,那么插了电的计算机是什么?&quot;答案是&quot;一堆会电人的废铁.&quot;这是因为没有软件的运行,计算机的功能就无从发挥了.就好像没有了灵魂的躯体也不过就是行尸走肉,重点在于软件/灵魂.所以下面咱们就得要了解一下&quot;软件&quot;是什么. 一般来说,目前的计算机系统将软件分为两大类,一个是系统软件,一个是应用程序.但鸟哥认为我们还是得要了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWxo5z.html" rel="bookmark">《FLUENT 14&period;0超级学习手册》&mdash;&mdash;第2章 FLUENT软件介绍2&period;1 FLUENT软件特点简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 FLUENT软件介绍 FLUENT 14.0超级学习手册 CFD商业软件FLUENT是通用CFD软件包,用来模拟从不可压缩到高度可压缩范围内的复杂流动.由于采用了多种求解方法和多重网格加速收敛技术,因而FLUENT能达到最佳的收敛速度和求解精度.灵活的非结构化网格和基于解的自适应网格技术及成熟的物理模型,使FLUENT在转换与湍流.传热与相变.化学反应与燃烧.多相流.旋转机械.动/变形网格.噪音.材料加工.燃料电池等方面有广泛的应用. 学习目标: 学习FLUENT软件的主要特点: 了解F			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqR4Rp.html" rel="bookmark" class="title">最新python错误  求解</a>
					<div>
						问题描述 最新python错误 求解 TypeError: 'iteration' is an invalid keyword argument for this function 解决方案 把ite ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3AWWp.html" rel="bookmark" class="title">Matt Powell的《Server-Side 异步Web Methhods》</a>
					<div>
						server|web|异步|异步 摘要:Matt Powell 介绍了如何在服务器端使用异步 Web 方法,来创建高性能的 Microsoft ASP.NET Web 服务. 简介 在九月份的第三篇专 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boDrdM.html" rel="bookmark" class="title">精简Flash文件体积的几个小技巧</a>
					<div>
						核心提示:小编经过长时间的使用,总结了几条为Flash减肥的小技巧,希望与各位闪客们分享. 小编经过长时间的使用,总结了几条为Flash减肥的小技巧,希望与各位闪客们分享. 1.尽量减少文字的叙述.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdkYNM.html" rel="bookmark" class="title">Adseo&colon;基于潜在消费者的关键词分析技巧</a>
					<div>
						正确的把握关键词,是所有SEO工作构建的基础.一个好的开始才能够将所有效果集中力量往正确的方向引导.目前,SEO技术在国内日趋成熟,跟随着搜索引擎算法的不断革新,SEO技术也几经历练.现今所有SEO的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdQxmz.html" rel="bookmark" class="title">Dreamweaver CS3 破解补丁&comma;注册码应用全过程</a>
					<div>
						过程|破解|dreamweaver|cs3 在官方网站下载了Adobe Dreamweaver CS3 英文正式版,约285M大小的安装包,安装过程大约需要十多分钟.安装完毕后,打开软件,提示需要注册 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxKrob.html" rel="bookmark" class="title">微软官方入门教程8：Vista系统我的视频大片随心做</a>
					<div>
						本文包括两部分,&quot;4步搞定家庭视频&quot;和&quot;大片是怎样练成的&quot;. 一.4步搞定家庭视频 您可以在Windows Vista 开始菜单搜索中输入&quot;Movie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62a6YM.html" rel="bookmark" class="title">算法系列（八） RLE行程长度压缩算法</a>
					<div>
						RLE(Run Length Encoding)行程长度压缩算法(也称游程长度压缩算法),是最早出现.也是 最简单的无损数据压缩算法.RLE算法的基本思路是把数据按照线性序列分成两种情况:一种是连续的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N5Vkz.html" rel="bookmark" class="title">Photoshop调出阿宝色效果调色教程</a>
					<div>
						本PS实例教程是关于使用Photoshop轻松调出阿宝色,教程步骤比较详细,希望能给你带来帮助! 先看看原图: 图1 再看看效果图: 图2 图3 图4 图5 图6 图7 图8 图9 图10 分类: P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7XEnM.html" rel="bookmark" class="title">IE浏览器图像大小自动调整教程</a>
					<div>
						  1.首先需要打开IE浏览器,找到设置之后将&quot;Internet选项&quot;打开; 2.在Internet选项窗口里面直接单击&quot;高级&quot;标签页; 3.接着找到&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKOPdM.html" rel="bookmark" class="title">蓝牙技术-蓝牙连接电子称读取重量的demo</a>
					<div>
						问题描述 蓝牙连接电子称读取重量的demo 您好!您之前在百度问的&lt;现在在研究一个蓝牙连接电子称读取重量的demo.但是研究了很久发现数据总是会有延迟,大概半秒左右.想问问各位大神,能否实现数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGZjDb.html" rel="bookmark" class="title">java定时任务实现的几种方式</a>
					<div>
						   在开发测试工具的应用后台,经常听到同事说要做个定时任务把做日志处理,或者数据清理,包括做些复杂的业务计算逻辑,在选择定时任务的时候,怎么能够快速实现,并且选择一种更适合自己的方式呢? 我这里把定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWZw0b.html" rel="bookmark" class="title">如何判断企业网站的推广效果</a>
					<div>
						在互联网渐渐成为主流媒体,企业已经认识到了网络推广的重要性,但是对于网络推广效果的衡量却依然存在困惑:我们企业在网络上推广了,怎么能看出来效果呢?中麒推广刘禹含认为对于企业网络推广效果的衡量应该主要从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaNLvM.html" rel="bookmark" class="title">iphone-扩大UIGestureRecognizer点击区域</a>
					<div>
						问题描述 扩大UIGestureRecognizer点击区域 在一些view中有点击动作,但是这些view太小了,点击的时候非常困难,而且这些动作是必须要求的,怎么样能扩大点击区域? 解决方案 如果你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkqvwb.html" rel="bookmark" class="title">云的一二三四五</a>
					<div>
						&quot;一&quot;云计算是一种颠覆性的交付模式,一体化的共享服务平台.从技术的角度来讲,是将企业所有的服务器.存储等基础设施以及网络整合到统一的云平台上.在&quot;云的世界&quot;里, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkPW4b.html" rel="bookmark" class="title">tomcat页面打不开</a>
					<div>
						问题描述 在使用springmvc时,经controller跳转到ss.jsp页面,显示正常,过一会儿不做任何操作,ss.jsp就会出问题,显示页面打不开,服务器是tomcat,这是什么情况? 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRBP3z.html" rel="bookmark" class="title">摩托 X Phone 配 5 寸屏，安装 Android 5&period;0</a>
					<div>
						据 DroidForums报道,摩托罗拉移动X Phone将是第一款装备Android 5.0(代号Key Lime Pie)的智能手机.之前曾有消息称,Google正与摩托罗拉移动合作开发X Pho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YVNgM.html" rel="bookmark" class="title">《MySQL技术内幕：InnoDB存储引擎第2版》&mdash;&mdash;1&period;1　定义数据库和实例</a>
					<div>
						1.1 定义数据库和实例 在数据库领域中有两个词很容易混淆,这就是&quot;数据库&quot;(database)和&quot;实例&quot;(instance).作为常见的数据库术语,这两个词的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyddVvb.html" rel="bookmark" class="title">擦亮眼睛分清楚云计算与网格计算大不同</a>
					<div>
						云计算与网格计算的主要区别在于:网格计算侧重于解决计算和存储资源的分配,即将大家提供的计算和存储资源根据各自应用的需要重新分配给大家;而云计算则倾向于计算.存储和应用资源的共享,在云计算中,用户不仅不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmY7Vb.html" rel="bookmark" class="title">《云安全原理与实践》&mdash;&mdash;2&period;1　云计算面临的技术风险</a>
					<div>
						2.1 云计算面临的技术风险 云计算服务模式将硬件.软件甚至应用交给经验丰富的云服务商来管理,客户通过网络来享受云服务商提供的服务,并可按需定制.弹性升缩.降低成本.但是,传统信息技术所面临的安全风险 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBLZDb.html" rel="bookmark" class="title">做个这样的网站 多少钱？</a>
					<div>
						问题描述 解决方案 解决方案二:看你用什么技术做了?要用Domino?解决方案三:根据技术.地区消费解决方案四:看什么样的人卖,什么样的人买,孔子学院......解决方案五:江苏宿迁润兴软件提供各种网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7yLnp.html" rel="bookmark" class="title">余额宝选择天弘基金的理由是什么？</a>
					<div>
						基金公司创新业务的推出,实际上是非常非常谨慎的,要考虑到许多方面: 一个是业务本身的合规性,这个是比较复杂而且很专业的,要过证监会这一关不容易: 一个是市场风险,基本上没人愿意冒险,基金公司现有的业务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYq6yp.html" rel="bookmark" class="title">xampp中的mysql运行七八秒后突然停止工作，如图，应该如何操作？求大神解答！</a>
					<div>
						问题描述 xampp中的mysql运行七八秒后突然停止工作,如图,应该如何操作?求大神解答! 解决方案 这是对应的日志文件					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNn75oM.html" rel="bookmark" class="title">一个APP最多可以创建多少个群呢？</a>
					<div>
						问题描述 10W, 100W, 没限制~~? 解决方案 不是一个app可以建多少群,现在是每个用户可以创建500个群.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkLn0M.html" rel="bookmark" class="title">Javascript中数组的sort&lpar;&rpar;和reverse&lpar;&rpar;方法</a>
					<div>
						Javascript开发中,数组是用到最多一个内容.同时数组的方法不多,下面介绍在数组排序中用到的2个常用方法.sort()方法和reverve()方法. sort()方法可以很容易将一个数组进行排序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq70xGz.html" rel="bookmark" class="title">纽约时报：亚马逊压低图书售价引发出版界不满</a>
					<div>
						图书是亚马逊的支柱业务之一,但出版商对这家http://www.aliyun.com/zixun/aggregation/34467.html&quot;&gt;电商巨头的压价行为感到无奈和愤怒. 导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwAW5M.html" rel="bookmark" class="title">利用sqldataAdapter&period;insertcommand插入数据问题</a>
					<div>
						问题描述 代码如下:1DimdefmmAsString=&quot;1234&quot;2DimxkdhAsString=Microsoft.VisualBasic.Left(ComboBox1.Te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL34vM.html" rel="bookmark" class="title">详解Java动态代理的实现机制&lowbar;java</a>
					<div>
						一.概述 代理是一种设计模式,其目的是为其他对象提供一个代理以控制对某个对象的访问,代理类负责为委托类预处理消息,过滤消息并转发消息以及进行消息被委托类执行后的后续处理.为了保持行为的一致性,代理类和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYA0Vb.html" rel="bookmark" class="title">js实现点击后将文字或图片复制到剪贴板的方法&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了js实现点击后将文字或图片复制到剪贴板的方法,代码非常简洁实用,具体功能代码如下所示: 实现复制文字代码: &lt;table width=&quot;99%&quot; border= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKknRz.html" rel="bookmark" class="title">sqlserver2005查询datetime范围问题&lpar;急&excl;急&excl;急&excl;&rpar;</a>
					<div>
						问题描述 我在sqlserver中有一个类型为datetime类型的列SignTime格式为&quot;2008-8-811:50:22&quot;现在写sql语句查询为什么为空?语句如下:strin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YRqDp.html" rel="bookmark" class="title">Rational Change for Rational ClearCase Interface配置工具使用指南</a>
					<div>
						本文面向对 Rational Change 和 Rational http://www.aliyun.com/zixun/aggregation/16442.html&quot;&gt;ClearCa ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
